<?php
ini_set('memory_limit',          '256M');
define('SOAP_REQUEST_START',      microtime());
define('SOAP_VALIDATE_INPUT',     false);
define('SOAP_VALIDATE_OUTPUT',    false);
define('SOAP_DEBUG',              false);
define ('SOAP_REQUEST_LOGFILE',   '/tmp/request.log');
define ('SOAP_RESPONSE_LOGFILE',  '/tmp/response.log');
include_once('./lib/config.service.php');

function ffn($str) {
  $res = ereg_replace('[^a-zA-Z0-9_]*', '', $str);
  if ($res != $str) {
    die('Illegal service name: '.$str);
  }
  return $str;
} // ffn()

do {
  // wsdl
  if (isset($_REQUEST['wsdl'])) {
    $serviceName = ucfirst(ffn($_REQUEST['wsdl']));
    if (($str = @file_get_contents('soap/'.$serviceName.'.wsdl', true))) {
      header('Content-Type: text/xml');

      echo str_replace ('MOODLE-WWWROOT', $CFG->wwwroot, $str);
      break;
    }
    die($serviceName.'.wsdl not found!');
  }
  
  // service
  $args = explode('&', $_SERVER['QUERY_STRING']);
  if (count($args) == 0 || !$args[0] || !isset ($GLOBALS['HTTP_RAW_POST_DATA']) || !$GLOBALS['HTTP_RAW_POST_DATA']) {
    error ('This is a soap service endpoint. Service description can be found <a href="./?wsdl=Moodle">here</a>, a <a href="./test.php">test form</a> is also available for moodle admins');
    break;
  }
  if ($serviceName = ucfirst(ffn($args[0]))) {
    include_once ('soap/'.$serviceName.'SoapServerProxy.php');
    if (!class_exists($serviceName.'SoapServerProxy'))
    {
      break;
    }
    $serviceClassName = $serviceName.'SoapServerProxy';
    new $serviceClassName();
  }
} while (false);
?>
