<?php
  header('Content-Type: text/html; charset=UTF-8');
  include_once ('soap/MoodleSoapClientTestForm.php');
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="content-type" content="text/html; charset=utf-8" />
    <title>Moodle Soap Service Test Suite</title>
    <style type="text/css">
      body,div,td,input,select,option {
        font-family:verdana,helvetica,arial,sans-serif;
        font-size:11px;
      }
      input,select {
        border:1px solid black;
        padding:2px;
      }
      option {
        border:0px solid transparent;
        padding:1px;
        padding-right:18px;
      }
      td {
        margin-left:10px;
        vertical-align:top;
        white-space:nowrap;
      }
      h1       { font-size:14px; }
      h2       { font-size:12px; }
      .type    { color:blue; }
      .shift   { margin-left:20px; }
      .comment { font-size:10px; color:gray; }
      .outputpanel {
         position:absolute; top:1px; left:0px; width:99%;
         text-align:center;
      }
      .output  { 
         text-align:left; z-index:2;
         width:80%; margin:auto; padding:5px;
         border:1px solid #cccccc;
         <?php 
         if (file_exists('./transbg.png')) {
          echo 'background-image:url(transbg.png);';
         }
         else {
          echo 'background-color:#f5ffdd;';
         }
         ?>
      }
      .button {
        text-decoration:none;
        border:1px solid black;
        color:black;
        background-color:white;
      }
    </style>
    <script language="JavaScript" type="text/javascript">
      document.dBuffer    = new Array();
      document.arrIndexes = new Array();

      function copy(elementId) {
        var source = document.getElementById(elementId + '_source'),
            target = document.getElementById(elementId + '_copy'),
            e = document.createElement('div');

        e.innerHTML = source.innerHTML;
        
        if (isNaN(document.arrIndexes[elementId])) {
          document.arrIndexes[elementId] = 0;
        }
        else {
          ++document.arrIndexes[elementId];
        }
        updateIndex(e, elementId, -1, document.arrIndexes[elementId]);
        document.dBuffer[elementId + '_' + document.arrIndexes[elementId]] = e;
        target.appendChild(e);
      } // copy()

      function deleteEntry(elementId) {
        if ((e = document.dBuffer[elementId])) {
          e.innerHTML = '';
          e.style.display = 'none';
        }
         var c      = elementId.search(/[0-9]*$/),
             index  = parseInt(elementId.substr(c)),
             prefix = elementId.substr(0, c - 1);

        if((e = document.dBuffer[prefix + '_' + (++index)])) {
          deleteEntry(prefix + '_' + index);
        }
        document.dBuffer[elementId] = null;
        document.arrIndexes[prefix] = index - 2;
      } // deleteEntry()
      
      function updateIndex(element, prefix, oldIndex, newIndex) {
         var searchStr = prefix + '_' + oldIndex,
            replStr   = prefix + '_' + newIndex,
            htmlSource    = element.innerHTML;
  
        while(htmlSource.indexOf(searchStr) > -1) {
          htmlSource = htmlSource.replace(searchStr, replStr);
        }
        element.innerHTML = htmlSource;
      } // updateIndex()

      function hide(panelId) {
        if ((e = document.forms.soaptestform.elements['status_' + panelId])) {
          e.value = '';
        }
        if ((e = document.getElementById('panel_' + panelId))) {
          e.style.display = 'none';
        }
        if ((e = document.getElementById('show_' + panelId))) {
          e.style.display = 'inline';
        }
        if ((e = document.getElementById('hide_' + panelId))) {
          e.style.display = 'none';
        }
      } // hide()

      function show(panelId) {
        if ((e = document.forms.soaptestform.elements['status_' + panelId])) {
          e.value = '1';
        }
        if ((e = document.getElementById('panel_' + panelId))) {
          e.style.display = 'block';
        }
        if ((e = document.getElementById('show_' + panelId))) {
          e.style.display = 'none';
        }
        if ((e = document.getElementById('hide_' + panelId))) {
          e.style.display = 'inline';
        }
      } // show()

      function clearEndpoint() {
        document.forms.soaptestform.elements.alt_endpoint.value = '';
      } // clearEndpoint()

      function toggleDisplay(elementId, toggle) {
        if (elementId == '') {
          toggleDisplay('xmloutput', false);
          // toggleDisplay('phpoutput', false);
        }
        var e = document.getElementById(elementId);
        if (!e) {
          return;
        }
        if (e.style.display == 'block' || toggle == false) {
          e.style.display = 'none';
        }
        else {
          e.style.display = 'block';
        }
        if (toggle) {
          toggleDisplay((elementId == 'xmloutput' ? 'phpoutput' : 'xmloutput'), false);
        }
      } // toggleDisplay()
    </script>
  </head>
  <body>
  <a name="pagetop" />
  <?php
  $tc = new MoodleSoapClientTestForm();
  $tc->evaluate();
  $tc->printForm();
  $tc->restoreFormArrays();
  $tc->restoreFormValues();
  ?>
  </body>
</html>
