<?php
include_once('soap/MoodleSoapClasses.php');

class MoodleSoapServerSkeleton {
  function MoodleSoapServerSkeleton() {
  } // MoodleSoapServerSkeleton()
  
  /**
   * moodle.MoodleSoapCallback::getCourses 
   * SOAP operation: getCourses
   *
   * Liste von Moodle-Kursen
   *
   * @param conditions     ArrayOfCondition (class MoodleSoapArrayOfCondition)
   *
   * @return courses   ArrayOfCourse (class MoodleSoapArrayOfCourse)
   *
   */
  function getCourses(&$conditions) {
    return /* courses */ new MoodleSoapArrayOfCourse(array(/* ..., */ /* courses */ new MoodleSoapCourse(/* id */ 4711
,/* title */ 'SOAP ROCKS'
,/* shortcut */ 'SOAP ROCKS'
,/* summary */ 'SOAP ROCKS'
,/* public */ true
,/* allowGuest */ true
,/* location */ 'SOAP ROCKS'
,/* teachers */ 'SOAP ROCKS'
)
))
;
  } // getCourses()
  
  /**
   * moodle.MoodleSoapCallback::getCategories 
   * SOAP operation: getCategories
   *
   * Liste von Moodle Kategorien (HU Struktur hierarchisch)
   *
   * @param conditions     ArrayOfCondition (class MoodleSoapArrayOfCondition)
   *
   * @return categories   ArrayOfCategory (class MoodleSoapArrayOfCategory)
   *
   */
  function getCategories(&$conditions) {
    return /* categories */ new MoodleSoapArrayOfCategory(array(/* ..., */ /* categories */ new MoodleSoapCategory(/* id */ 4711
,/* title */ 'SOAP ROCKS'
,/* location */ 'SOAP ROCKS'
)
))
;
  } // getCategories()

} // class MoodleSoapServerSkeleton
?>
